//***************************************************
// Help-Library
//
// Stellt einige ueberall benoetigte Routinen fr den
// MSP430F149 bereit.
//***************************************************

void External_OSC_on(void)
{
  int i;
  BCSCTL1 &= ~XT2OFF;     // XT2 an
  do 
  {                       // pruefroutine, ob 8 Mhz-oszillator schon stabil ist
    IFG1 &= ~OFIFG;       // OSCFault flag loeschen (zeigt oszillatorfehler an)
    for (i=0xFF;i>0;i--); // warten, ob es wieder gesetzt wird
  }
  while (IFG1 & OFIFG);   // OSCFault immer noch gesetzt?       
  BCSCTL2 |= SELM_2 + SELS;  // MCLK = SMCLK = XT2
}

void wait(unsigned int i)
{
  unsigned int j, k;
  for(j=0;j<i;j++) for(k=0;k<80;k++);
}

double abs(double value)
{
  if (value<0) value=0-value;
  return value;
}

void IntToString(char* str, int value, char precomma, char aftercomma)
{
  int k, i, digit, multiplier, j=0;
  for (i=0;i<precomma;i++)
  {
    multiplier=1;
    for (k=0;k<precomma+aftercomma-i-1;k++) multiplier*=10;
    digit = value / multiplier;
    value %= multiplier;
    str[j++] = digit + 48;
  }
  if (aftercomma) str[j++] = '.';
  for (i=0;i<aftercomma;i++)
  {
    multiplier=1;
    for (k=0;k<aftercomma-i-1;k++) multiplier*=10;
    digit = value / multiplier;
    value %= multiplier;
    str[j++] = digit + 48;
  }
  
/*  int a, j=0;
  a = value / 1000;
  value %= 1000;
  str[j++] = a + 48;
  a = value / 100;
  value %= 100;
  str[j++] = a + 48;
  a = value / 10;
  value %= 10;
  str[j++] = a + 48;
  str[j++] = value + 48;*/
}
