void wait_precise(unsigned int i);
void LCDOutc(char str);
void LCDInit(void);
void LCDClear(void);
void LCDHome(void);
void LCDClock(void);
void LCDSetRow(char goto_row);
void LCDOuts(char* str);

unsigned char chars, row;

void wait_precise(unsigned int i)       // praeziser, wird nur fuer triac-zuendung benoetigt
{                                       // wartet i * 0,1ms
  unsigned int j, k;
  for(k=0;k<46;k++)
  {
    for(j=0;j<i;j++);
  }
}

void LCDClock(void)
{
  wait(1);
  P5OUT|=0x04;                          // clock-bit erst mal sicherheitshalber auf high
  wait(1);
  P5OUT&=~0x04;                         // und jetzt auf low
  wait(1);
}

void LCDClear(void)
{
  row=0;                                // zeilen- und zeichencounter resetten
  chars=0;
  P4OUT=0x01;                           // clear display
  P5OUT|=0x04;                          // E high
  P5OUT&=~0x03;                         // RS und R/W low
  LCDClock();                           // befehl ausfuehren
  wait(10);                             // clear display braucht was laenger
}

void LCDHome(void)
{
  row=0;                                // zeilen- und zeichencounter resetten
  chars=0;
  P4OUT=0x02;                           // nur return home, ohne clear display
  P5OUT|=0x04;                          // E high
  P5OUT&=~0x03;                         // RS und R/W low
  LCDClock();                           // befehl ausfuehren
  wait(10);                             // return home braucht was laenger
}

void LCDOutc(char str)
{
  switch (str)
  {
    case '':
      str = 0xE1;
      break;
    case '':
      str = 0xEF;
      break;
    case '':
      str = 0xF5;
      break;
    case '':
      str = 0xE2;
      break;
    case '':
      str = 0xDF;
      break;
    case '':
      str = 0xE4;
      break;
  }
  P4OUT=str;                            // str einfach an den port schicken
  P5OUT|=0x05;                          // RS und E high
  P5OUT&=~0x02;                         // R/W low
  LCDClock();                           // befehl ausfuehren
  chars++;                              // zaehlvar. eins erhoehen
  if (chars==20)                        // zeile voll?
  {
    row^=1;                             // toggle row
    chars=0;                            // reset chars
    if (row==1)
    {
      P4OUT=0xC0;                       // in die zweite zeile springen
      P5OUT|=0x04;                      // E high
      P5OUT&=~0x03;                     // RS und R/W low
      LCDClock();                       // befehl ausfuehren
    }
    else
    {
      LCDHome();                        // wieder zurueck in die erste zeile springen
    }
  }
}

void LCDOuts(char* str)
{
  while (*str != 0) LCDOutc(*str++);
}

void LCDSetRow(char goto_row)
{
  row=goto_row;
  chars=0;
}

void LCDInit(void)
{
  wait(10);                             // display braucht ein wenig zeit nach power-on
  P4OUT=0x38;                           // 8 bit operation, 2-zeilen-display, 5*8 dot font
  P5OUT|=0x04;                          // E high
  P5OUT&=~0x03;                         // RS und R/W low
  LCDClock();                           // befehl ausfuehren
  P4OUT=0x0C;                           // display anschalten, cursor aus, cursor blinkt nicht
  P5OUT|=0x04;                          // E high
  P5OUT&=~0x03;                         // RS und R/W low
  LCDClock();                           // befehl ausfuehren
  P4OUT=0x06;                           // cursorrichtung: nach rechts; kein display-shift
  P5OUT|=0x04;                          // E high
  P5OUT&=~0x03;                         // RS und R/W low
  LCDClock();                           // befehl ausfuehren
}
