//***************************************************
// TMP100-Library
//
// Stellt Routinen zum Auslesen des Temperatursensors
// TMP100 von Texas Instruments bereit. Der Sensor
// wird ueber I2C angeschlossen. Diese Library benoe-
// tigt die Library i2c.c, welche die I2C-Befehle zur
// Verfuegung stellt.
//***************************************************

#include "i2c.c"

void ReadTMP100(char* temp_str, char address)
{
  double temp_double;     // double-variable fuer die temperatur

  I2C_start();            // START senden
  I2C_init(address, 'w'); // den sensor auslesen
  while (!(I2C_gotACK())); I2C_sendbyte(0x01);  // pointer register: P1=0, P0=1 (d.h.: config. reg. ansprechen)
  while (!(I2C_gotACK())); I2C_sendbyte(0x40);  // TMP100 auf 11-bit-modus stellen
  while (!(I2C_gotACK())); I2C_start();
  I2C_init(address, 'w'); // address: I2C-adresse des auszulesenden TMP1000; schreibender zugriff
  while (!(I2C_gotACK())); I2C_sendbyte(0x00);  // pointer register: P1=0, P0=0 (d.h.: temperaturreg. ansprechen)
  while (!(I2C_gotACK())); I2C_start();  // repeated start senden
  I2C_init(address, 'r'); // erneut den TMP100 adressieren
  while (!(I2C_gotACK()));
  temp_double=I2C_receivebyte();  // die ersten 8 bit des 16-bit-temperaturwertes empfangen
  I2C_sendACK();
  temp_double+=(I2C_receivebyte()/256); // die nchsten 8 bit des 16-bit-temperaturwertes empfangen
  I2C_sendACK();
  I2C_stop();             // STOP senden
  IntToString(temp_str, 10*temp_double, 2, 1);
}
